# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mavros_msgs/NavControllerOutput.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class NavControllerOutput(genpy.Message):
  _md5sum = "f6340c9bb79e3ac2a6142ce592e66756"
  _type = "mavros_msgs/NavControllerOutput"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# https://mavlink.io/en/messages/common.html#NAV_CONTROLLER_OUTPUT

std_msgs/Header header

float32 nav_roll            # Current desired roll
float32 nav_pitch           # Current desired pitch
int16 nav_bearing           # Current desired heading
int16 target_bearing        # Bearing to current waypoint/target
uint16 wp_dist              # Distance to active waypoint
float32 alt_error           # Current altitude error
float32 aspd_error          # Current airspeed error
float32 xtrack_error        # Current crosstrack error on x-y plane
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','nav_roll','nav_pitch','nav_bearing','target_bearing','wp_dist','alt_error','aspd_error','xtrack_error']
  _slot_types = ['std_msgs/Header','float32','float32','int16','int16','uint16','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,nav_roll,nav_pitch,nav_bearing,target_bearing,wp_dist,alt_error,aspd_error,xtrack_error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NavControllerOutput, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.nav_roll is None:
        self.nav_roll = 0.
      if self.nav_pitch is None:
        self.nav_pitch = 0.
      if self.nav_bearing is None:
        self.nav_bearing = 0
      if self.target_bearing is None:
        self.target_bearing = 0
      if self.wp_dist is None:
        self.wp_dist = 0
      if self.alt_error is None:
        self.alt_error = 0.
      if self.aspd_error is None:
        self.aspd_error = 0.
      if self.xtrack_error is None:
        self.xtrack_error = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.nav_roll = 0.
      self.nav_pitch = 0.
      self.nav_bearing = 0
      self.target_bearing = 0
      self.wp_dist = 0
      self.alt_error = 0.
      self.aspd_error = 0.
      self.xtrack_error = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2f2hH3f().pack(_x.nav_roll, _x.nav_pitch, _x.nav_bearing, _x.target_bearing, _x.wp_dist, _x.alt_error, _x.aspd_error, _x.xtrack_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 26
      (_x.nav_roll, _x.nav_pitch, _x.nav_bearing, _x.target_bearing, _x.wp_dist, _x.alt_error, _x.aspd_error, _x.xtrack_error,) = _get_struct_2f2hH3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2f2hH3f().pack(_x.nav_roll, _x.nav_pitch, _x.nav_bearing, _x.target_bearing, _x.wp_dist, _x.alt_error, _x.aspd_error, _x.xtrack_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 26
      (_x.nav_roll, _x.nav_pitch, _x.nav_bearing, _x.target_bearing, _x.wp_dist, _x.alt_error, _x.aspd_error, _x.xtrack_error,) = _get_struct_2f2hH3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f2hH3f = None
def _get_struct_2f2hH3f():
    global _struct_2f2hH3f
    if _struct_2f2hH3f is None:
        _struct_2f2hH3f = struct.Struct("<2f2hH3f")
    return _struct_2f2hH3f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
