// Auto-generated. Do not edit!

// (in-package mavros_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Waypoint = require('./Waypoint.js');

//-----------------------------------------------------------

class WaypointList {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.current_seq = null;
      this.waypoints = null;
    }
    else {
      if (initObj.hasOwnProperty('current_seq')) {
        this.current_seq = initObj.current_seq
      }
      else {
        this.current_seq = 0;
      }
      if (initObj.hasOwnProperty('waypoints')) {
        this.waypoints = initObj.waypoints
      }
      else {
        this.waypoints = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type WaypointList
    // Serialize message field [current_seq]
    bufferOffset = _serializer.uint16(obj.current_seq, buffer, bufferOffset);
    // Serialize message field [waypoints]
    // Serialize the length for message field [waypoints]
    bufferOffset = _serializer.uint32(obj.waypoints.length, buffer, bufferOffset);
    obj.waypoints.forEach((val) => {
      bufferOffset = Waypoint.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type WaypointList
    let len;
    let data = new WaypointList(null);
    // Deserialize message field [current_seq]
    data.current_seq = _deserializer.uint16(buffer, bufferOffset);
    // Deserialize message field [waypoints]
    // Deserialize array length for message field [waypoints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.waypoints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.waypoints[i] = Waypoint.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 45 * object.waypoints.length;
    return length + 6;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mavros_msgs/WaypointList';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '0605a2df153acd9a4a4823385ed81b57';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # WaypointList.msg
    #
    #  :current_seq:   seq nr of currently active waypoint
    #                  waypoints[current_seq].is_current == True
    #
    #  :waypoints:     list of waypoints
    
    uint16 current_seq
    mavros_msgs/Waypoint[] waypoints
    
    ================================================================================
    MSG: mavros_msgs/Waypoint
    # Waypoint.msg
    #
    # ROS representation of MAVLink MISSION_ITEM
    # See mavlink documentation
    
    
    
    # see enum MAV_FRAME
    uint8 frame
    uint8 FRAME_GLOBAL = 0
    uint8 FRAME_LOCAL_NED = 1
    uint8 FRAME_MISSION = 2
    uint8 FRAME_GLOBAL_REL_ALT = 3
    uint8 FRAME_LOCAL_ENU = 4
    uint8 FRAME_GLOBAL_INT = 5
    uint8 FRAME_GLOBAL_RELATIVE_ALT_INT = 6
    uint8 FRAME_LOCAL_OFFSET_NED = 7
    uint8 FRAME_BODY_NED = 8
    uint8 FRAME_BODY_OFFSET_NED = 9
    uint8 FRAME_GLOBAL_TERRAIN_ALT = 10
    uint8 FRAME_GLOBAL_TERRAIN_ALT_INT = 11
    uint8 FRAME_BODY_FRD = 12
    uint8 FRAME_RESERVED_13 = 13
    uint8 FRAME_RESERVED_14 = 14
    uint8 FRAME_RESERVED_15 = 15
    uint8 FRAME_RESERVED_16 = 16
    uint8 FRAME_RESERVED_17 = 17
    uint8 FRAME_RESERVED_18 = 18
    uint8 FRAME_RESERVED_19 = 19
    uint8 FRAME_LOCAL_FRD = 20
    uint8 FRAME_LOCAL_FLU = 21
    
    # see enum MAV_CMD and CommandCode.msg
    uint16 command
    
    bool is_current
    bool autocontinue
    # meaning of this params described in enum MAV_CMD
    float32 param1
    float32 param2
    float32 param3
    float32 param4
    float64 x_lat
    float64 y_long
    float64 z_alt
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new WaypointList(null);
    if (msg.current_seq !== undefined) {
      resolved.current_seq = msg.current_seq;
    }
    else {
      resolved.current_seq = 0
    }

    if (msg.waypoints !== undefined) {
      resolved.waypoints = new Array(msg.waypoints.length);
      for (let i = 0; i < resolved.waypoints.length; ++i) {
        resolved.waypoints[i] = Waypoint.Resolve(msg.waypoints[i]);
      }
    }
    else {
      resolved.waypoints = []
    }

    return resolved;
    }
};

module.exports = WaypointList;
